'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = RecordButtonBar;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _cspaceInput = require('cspace-input');

var _RecordButtonBar = require('../../../styles/cspace-ui/RecordButtonBar.css');

var _RecordButtonBar2 = _interopRequireDefault(_RecordButtonBar);

var _SaveButton = require('../../../styles/cspace-ui/SaveButton.css');

var _SaveButton2 = _interopRequireDefault(_SaveButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Button = _cspaceInput.components.Button;


var messages = (0, _reactIntl.defineMessages)({
  save: {
    'id': 'recordButtonBar.save',
    'defaultMessage': 'Save'
  }
});

var propTypes = {
  isModified: _react.PropTypes.bool,
  isSavePending: _react.PropTypes.bool,
  onSaveButtonClick: _react.PropTypes.func
};

function RecordButtonBar(props) {
  var isModified = props.isModified,
      isSavePending = props.isSavePending,
      onSaveButtonClick = props.onSaveButtonClick;


  var className = void 0;

  if (isSavePending) {
    className = _SaveButton2.default.pending;
  } else if (isModified) {
    className = _SaveButton2.default.normal;
  } else {
    className = _SaveButton2.default.done;
  }

  return _react2.default.createElement(
    'div',
    { className: _RecordButtonBar2.default.common },
    _react2.default.createElement(
      Button,
      {
        className: className,
        disabled: isSavePending,
        icon: true,
        name: 'save',
        onClick: onSaveButtonClick
      },
      _react2.default.createElement(_reactIntl.FormattedMessage, messages.save)
    )
  );
}

RecordButtonBar.propTypes = propTypes;